import time
import Adafruit_WS2801
import os
from neopixel import *
from random import randint

#Configure NEOPIXEL options
LED_COUNT      = 7       # Number of LED pixels.
LED_PIN        = 18      # GPIO pin connected to the pixels (must support PWM!).
LED_FREQ_HZ    = 800000  # LED signal frequency in hertz (usually 800khz)
LED_DMA        = 5       # DMA channel to use for generating signal (try 5)
LED_BRIGHTNESS = 255     # Set to 0 for darkest and 255 for brightest
LED_INVERT     = False   # True to invert the signal (when using NPN transistor level shift)

#Configure colors (variable - HEX colorcode - NLname)
BLUE 		= 0x0bfff, "Blauw"
BLUELIGHT 	= 0x98c2fb, "Lichtblauw"
BLUEDARK 	= 0x0000ff, "Donkerblauw"
GREY 		= 0xc3c3c3, "Grijs"
GREYLIGHT 	= 0xf4f4f4, "Lichtgrijs"
GREYDARK 	= 0xfefefe, "Donkergrijs"
ORANGE 		= 0xffcc00, "Oranje"
PINK		= 0xff4de8, "Roze"
PURPLE 		= 0xe400ff, "Paars"
RED 		= 0xFF0000, "Rood"
REDLIGHT 	= 0xff5a2e, "Lichtrood"
REDDARK 	= 0xc80909, "Donkerrood"
WHITE 		= 0xffffff, "Wit"
YELLOW 		= 0xfff600, "Geel"
OFF			= 0x000000, "Niet Gedefinieerd"

#Default Program Variables
USERMENU	        	= 1 	# If this variable is 1 than the usermenu will show. If this variable is 0 than the light will use auto-setting
DEFAULTLIGHTSONSTART	= 1 	# If this variable is 1 the default lights will always be shown. If set to 0 the default is to leave the lights off

#Define Default Lights
def defaultlights():
    strip.setBrightness(254);
    strip.setPixelColor(0,(WHITE[0]));
    strip.setPixelColor(1,(WHITE[0]));
    strip.setPixelColor(2,(WHITE[0]));
    strip.setPixelColor(3,(WHITE[0]));
    strip.setPixelColor(4,(WHITE[0]));
    strip.setPixelColor(5,(WHITE[0]));
    strip.setPixelColor(6,(WHITE[0]));
    strip.setPixelColor(7,(WHITE[0]));

#Initialize library
strip = Adafruit_NeoPixel(LED_COUNT, LED_PIN, LED_FREQ_HZ, LED_DMA, LED_INVERT, LED_BRIGHTNESS)

#Prepare data pin for NEOPixel output
strip.setBrightness(LED_BRIGHTNESS);
strip.begin();
strip.show(); # Initialize all pixels to 'off'

#Turn on default lights if is true, else dim the lights
if DEFAULTLIGHTSONSTART == 1:
    defaultlights()
    
strip.show();

#USER MENU
while USERMENU == 1:
	KEUZEMENU = 1 # This variable sets the default behaviour of the user light menu back to defaults
	os.system('cls')  # on windows
	os.system('clear')  # on linux / os x
	print("---------------------------------------")
	print("JARNO'S KERSTHUISJE CONTROLE MENU:")
	print("---------------------------------------")
	print("")
	print("Wat wil je gaan doen?")
	print(".....................")
	print("")
	print("1 = Standaard lampjes")
	print("")
	print("2 = Lampkleuren zelf definieren")
	print("")
	print("3 = Disco Wit")
	print("")
	print("4 = Disco - alle kleuren")
	print("")
	print("5 = Regenboog - lampjes zelfde kleur")
	print("")
	print("6 = Regenboog - lampjes andere kleur")
	print("")
	print("7 = Verspringende lampjes")
	print("")
	print("8 = Lampjes uit")
	print("")
	print("9 = Raspberry Pi afsluiten")
	print("")
	print("(Gebruik CTRL+C bij optie 3, 4, 5, 6 en 7 om de loop te eindigen.)")
	print("")
	print("")
	HOOFDMENU = input("Maak je keuze: ")

	if HOOFDMENU == "1":
		#Turn on the default light settings as defined
		defaultlights()

	if HOOFDMENU == "2":
		#Define your own light colors
			
		while KEUZEMENU != 2:
		#Choose the light to set

			os.system('cls')  # on windows
			os.system('clear')  # on linux / os x
			print("KIES JE LAMPJE:")
			print("---------------------------------------")
			print("")
			print("1 = Eetkamer")
			print("")
			print("2 = Woonkamer")
			print("")
			print("3 = Zolder1")
			print("")
			print("4 = Zolder2")
			print("")
			print("5 = Zolder3")
			print("")
			print("6 = Buitenlamp")
			print("")
			print("7 = Zithoek")
			print("")
			print("8 = Stel de brightness (felheid) in")
			print("")
			print("")
			LAMP = int(input("Kies je lampje: "))

			#Assign a LED number (int)
			if LAMP == 1:
				LAMPNUMMER = 0
				
			if LAMP == 2:
				LAMPNUMMER = 1
				
			if LAMP == 3:
				LAMPNUMMER = 2
				
			if LAMP == 4:
				LAMPNUMMER = 3
				
			if LAMP == 5:
				LAMPNUMMER = 4
				
			if LAMP == 6:
				LAMPNUMMER = 5
				
			if LAMP == 7:
				LAMPNUMMER = 6

			if LAMP != 8:

				#Colormenu used by all lights to set a lightcolor
				os.system('cls')  # on windows
				os.system('clear')  # on linux / os x
				print("KIES DE KLEUR:")
				print("---------------------------------------")
				print("")
				print("a = Blauw")
				print("b = Lichtblauw")
				print("c = Donkerblauw")
				print("d = Grijs")
				print("e = Lichtgrijs")
				print("f = Donkergrijs")
				print("g = Oranje")
				print("h = Roze")
				print("i = Paars")
				print("j = Rood")
				print("k = Lichtrood")
				print("l = Donkerrood")
				print("m = Wit")
				print("n = Geel")
				print("o = Uit")
				print("")
				print("")
				LAMPKLEUR = input("Kies je kleur: ")

				#Give KLEUR variable a value
				if LAMPKLEUR == "a":
					KLEUR = BLUE
				elif LAMPKLEUR == "b":
					KLEUR = BLUELIGHT
				elif LAMPKLEUR == "c":
					KLEUR = BLUEDARK
				elif LAMPKLEUR == "d":
					KLEUR = GREY
				elif LAMPKLEUR == "e":
					KLEUR = GREYLIGHT
				elif LAMPKLEUR == "f":
					KLEUR = GREYDARK
				elif LAMPKLEUR == "g":
					KLEUR = ORANGE
				elif LAMPKLEUR == "h":
					KLEUR = PINK
				elif LAMPKLEUR == "i":
					KLEUR = PURPLE
				elif LAMPKLEUR == "j":
					KLEUR = RED
				elif LAMPKLEUR == "k":
					KLEUR = REDLIGHT
				elif LAMPKLEUR == "l":
					KLEUR = REDDARK
				elif LAMPKLEUR == "m":
					KLEUR = WHITE
				elif LAMPKLEUR == "n":
					KLEUR = YELLOW
				elif LAMPKLEUR == "o":
					KLEUR = OFF
				else:
					KLEUR = OFF

                #Assign the right HEX color (KLEUR) to the right light (LAMPNUMMER)
				strip.setPixelColor(LAMPNUMMER,(KLEUR[0]));

				#Set the LAMPKLEUR variable for overview page
				if LAMPNUMMER == 0:
					LAMPKLEUR1 = KLEUR[1]
				if LAMPNUMMER == 1:
					LAMPKLEUR2 = KLEUR[1]
				if LAMPNUMMER == 2:
					LAMPKLEUR3 = KLEUR[1]
				if LAMPNUMMER == 3:
					LAMPKLEUR4 = KLEUR[1]
				if LAMPNUMMER == 4:
					LAMPKLEUR5 = KLEUR[1]
				if LAMPNUMMER == 5:
					LAMPKLEUR6 = KLEUR[1]
				if LAMPNUMMER == 6:
					LAMPKLEUR7 = KLEUR[1]

			if LAMP == 8:
				BRIGHTNESS = int(input("Geef een waarde op: 0 = uit en 254 = maximaal!"))
				strip.setBrightness(BRIGHTNESS);

			#Print current lamp/light configuration
			os.system('cls')  # on windows
			os.system('clear')  # on linux / os x
			print("HUIDIGE CONFIGURATIE:")
			print("---------------------------------------")
			print("")
			try:
				LAMPKLEUR1
			except NameError:
				print ("Lamp1 is nog niet gedefinieerd")
			else:
				print ("Lamp1 is ingesteld op", LAMPKLEUR1)
			  
			try:
				LAMPKLEUR2
			except NameError:
				print ("Lamp2 is nog niet gedefinieerd")
			else:
				print ("Lamp2 is ingesteld op", LAMPKLEUR2)

			try:
				LAMPKLEUR3
			except NameError:
				print ("Lamp3 is nog niet gedefinieerd")
			else:
				print ("Lamp3 is ingesteld op", LAMPKLEUR3)

			try:
				LAMPKLEUR4
			except NameError:
				print ("Lamp4 is nog niet gedefinieerd")
			else:
				print ("Lamp4 is ingesteld op", LAMPKLEUR4)

			try:
				LAMPKLEUR5
			except NameError:
				print ("Lamp5 is nog niet gedefinieerd")
			else:
				print ("Lamp5 is ingesteld op", LAMPKLEUR5)

			try:
				LAMPKLEUR6
			except NameError:
				print ("Lamp6 is nog niet gedefinieerd")
			else:
				print ("Lamp6 is ingesteld op", LAMPKLEUR6)

			try:
				LAMPKLEUR7
			except NameError:
				print ("Lamp7 is nog niet gedefinieerd")
			else:
				print ("Lamp7 is ingesteld op", LAMPKLEUR7)
			  
			try:
				BRIGHTNESS
			except NameError:
				print ("De brightness is niet ingesteld en dus maximaal 254")
			else:
				print ("De brightness is ingesteld op", BRIGHTNESS)
			print("")
			print("")
			print("Wat wil je doen?")
			print("")
			print("1 = Ander lampje instellen")
			print("")
			print("2 = Done, kleur de lampjes!")
			print("")
			KEUZEMENU = int(input("Maak je keuze: "))

	if HOOFDMENU == "3":
	#Disco White Lights

		def theaterChase(strip, color, wait_ms=50, iterations=10):
			"""Movie theater light style chaser animation."""
			for j in range(iterations):
				for q in range(3):
					for i in range(0, strip.numPixels(), 3):
						strip.setPixelColor(i+q, color)
					strip.show()
					time.sleep(wait_ms/1000.0)
					for i in range(0, strip.numPixels(), 3):
						strip.setPixelColor(i+q, 0)
		
		while True:
			theaterChase(strip, Color(127, 127, 127))

	if HOOFDMENU == "4":
	#Disco - colored

		def wheel(pos):
			"""Generate rainbow colors across 0-255 positions."""
			if pos < 85:
				return Color(pos * 3, 255 - pos * 3, 0)
			elif pos < 170:
				pos -= 85
				return Color(255 - pos * 3, 0, pos * 3)
			else:
				pos -= 170
				return Color(0, pos * 3, 255 - pos * 3)
		
		def theaterChaseRainbow(strip, wait_ms=50):
			"""Rainbow movie theater light style chaser animation."""
			for j in range(256):
				for q in range(3):
					for i in range(0, strip.numPixels(), 3):
						strip.setPixelColor(i+q, wheel((i+j) % 255))
					strip.show()
					time.sleep(wait_ms/1000.0)
					for i in range(0, strip.numPixels(), 3):
						strip.setPixelColor(i+q, 0)
						
		while True:	
			theaterChaseRainbow(strip)

	if HOOFDMENU == "5":
	#Rainbow effect - all lights the same color

		def wheel(pos):
			"""Generate rainbow colors across 0-255 positions."""
			if pos < 85:
				return Color(pos * 3, 255 - pos * 3, 0)
			elif pos < 170:
				pos -= 85
				return Color(255 - pos * 3, 0, pos * 3)
			else:
				pos -= 170
				return Color(0, pos * 3, 255 - pos * 3)
		
		def rainbow(strip, wait_ms=20, iterations=1):
			"""Draw rainbow that fades across all pixels at once."""
			for j in range(256*iterations):
				for i in range(strip.numPixels()):
					strip.setPixelColor(i, wheel((i+j) & 255))
				strip.show()
				time.sleep(wait_ms/1000.0)
		
		while True:
			rainbow(strip)

	if HOOFDMENU == "6":
	# Rainbow effect - all lights a different color
		
		def wheel(pos):
			"""Generate rainbow colors across 0-255 positions."""
			if pos < 85:
				return Color(pos * 3, 255 - pos * 3, 0)
			elif pos < 170:
				pos -= 85
				return Color(255 - pos * 3, 0, pos * 3)
			else:
				pos -= 170
				return Color(0, pos * 3, 255 - pos * 3)


		def rainbowCycle(strip, wait_ms=20, iterations=5):
			"""Draw rainbow that uniformly distributes itself across all pixels."""
			for j in range(256*iterations):
				for i in range(strip.numPixels()):
					strip.setPixelColor(i, wheel((int(i * 256 / strip.numPixels()) + j) & 255))
				strip.show()
				time.sleep(wait_ms/1000.0)
		
		while True:
			rainbowCycle(strip)

	if HOOFDMENU == "7":
	#Jumping lights effect
		
		def colorWipe(strip, color, wait_ms=50):
			"""Wipe color across display a pixel at a time."""
			for i in range(strip.numPixels()):
				strip.setPixelColor(i, color)
				strip.show()
				time.sleep(wait_ms/1000.0)
		
		while True:
			colorWipe(strip, Color(255, 0, 0), 0)  # Red wipe
			time.sleep(2)
			colorWipe(strip, Color(0, 255, 0), 0)  # Blue wipe
			time.sleep(2)
			colorWipe(strip, Color(0, 0, 255), 0)  # Green wipe
			time.sleep(2)
			colorWipe(strip, Color(0, 0, 0, 255), 0)  # White wipe
			time.sleep(2)
			colorWipe(strip, Color(255, 255, 255), 0)  # Composite White wipe
			time.sleep(2)
			colorWipe(strip, Color(255, 255, 255, 255), 0)  # Composite White + White LED wipe
			time.sleep(2)

	if HOOFDMENU == "8":
	#Dim all the lights

		strip.setPixelColor(0, (OFF[0]));
		strip.setPixelColor(1, (OFF[0]));
		strip.setPixelColor(2, (OFF[0]));
		strip.setPixelColor(3, (OFF[0]));
		strip.setPixelColor(4, (OFF[0]));
		strip.setPixelColor(5, (OFF[0]));
		strip.setPixelColor(6, (OFF[0]));
		strip.setPixelColor(7, (OFF[0]));
		LAMPKLEUR1 = OFF
		LAMPKLEUR2 = OFF
		LAMPKLEUR3 = OFF
		LAMPKLEUR4 = OFF
		LAMPKLEUR5 = OFF
		LAMPKLEUR6 = OFF
		LAMPKLEUR7 = OFF

	if HOOFDMENU == "9":
	#Shutdown Raspberry Pi

		os.system('sudo shutdown now')

	#Push settings on the strip
	strip.show();
